package com.ktg.iscs.service.impl;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ktg.common.utils.StringUtils;
import com.ktg.iscs.domain.IsIsolationPoint;
import com.ktg.iscs.domain.IsLotoSwitchMap;
import com.ktg.iscs.domain.IsMap;
import com.ktg.iscs.domain.dto.point.SwitchBindingPointDTO;
import com.ktg.iscs.domain.vo.loto.IsLotoSwitchMapVO;
import com.ktg.iscs.mapper.IsLotoSwitchMapMapper;
import com.ktg.iscs.service.IIsIsolationPointService;
import com.ktg.iscs.service.IIsLotoSwitchMapService;
import com.ktg.iscs.service.IIsMapService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 开关布局Service业务层处理
 *
 * @author cgj
 * @date 2025-08-21
 */
@Service
public class IsLotoSwitchMapServiceImpl extends ServiceImpl<IsLotoSwitchMapMapper, IsLotoSwitchMap> implements IIsLotoSwitchMapService {

    @Autowired
    private IsLotoSwitchMapMapper isLotoSwitchMapMapper;
    @Autowired
    private IIsMapService isMapService;
    @Autowired
    private IIsIsolationPointService iIsIsolationPointService;

    @Override
    public Page<IsLotoSwitchMapVO> getIsLotoSwitchMapPage(Page<IsLotoSwitchMap> page, IsLotoSwitchMap isLotoSwitchMap) {
        return isLotoSwitchMapMapper.getIsLotoSwitchMapPage(page, isLotoSwitchMap);
    }

    @Override
    public Boolean insertIsLotoSwitchMap(IsLotoSwitchMap isLotoSwitchMap) {
        Assert.notBlank(isLotoSwitchMap.getSwitchMapName(), "名称不可为空！");
        // 判断名称重复
        List<IsLotoSwitchMap> list = list(Wrappers.<IsLotoSwitchMap>lambdaQuery()
                .eq(IsLotoSwitchMap::getSwitchMapName, isLotoSwitchMap.getSwitchMapName()));
        Assert.isTrue(list.isEmpty(), "该名称已被使用，请重新填写！");
        // 判断序列号重复
        List<IsLotoSwitchMap> list1 = list(Wrappers.<IsLotoSwitchMap>lambdaQuery()
                .eq(IsLotoSwitchMap::getSerialNumber, isLotoSwitchMap.getSerialNumber()));
        Assert.isTrue(list1.isEmpty(), "该序列号已被使用，请重新填写！");
        return save(isLotoSwitchMap);
    }

    @Override
    public Boolean updateIsLotoSwitchMap(IsLotoSwitchMap isLotoSwitchMap) {
        Assert.notNull(isLotoSwitchMap.getSwitchMapId(), "主键id不能为空！");
        // 判断名称重复
        List<IsLotoSwitchMap> list = list(Wrappers.<IsLotoSwitchMap>lambdaQuery()
                .eq(IsLotoSwitchMap::getSwitchMapName, isLotoSwitchMap.getSwitchMapName())
                .ne(IsLotoSwitchMap::getSwitchMapId, isLotoSwitchMap.getSwitchMapId()));
        Assert.isTrue(list.isEmpty(), "该名称已被使用，请重新填写！");
        // 判断序列号重复
        List<IsLotoSwitchMap> list1 = list(Wrappers.<IsLotoSwitchMap>lambdaQuery()
                .eq(IsLotoSwitchMap::getSerialNumber, isLotoSwitchMap.getSerialNumber())
                .ne(IsLotoSwitchMap::getSwitchMapId, isLotoSwitchMap.getSwitchMapId()));
        Assert.isTrue(list1.isEmpty(), "该序列号已被使用，请重新填写！");
        update(Wrappers.<IsLotoSwitchMap>lambdaUpdate()
                .eq(IsLotoSwitchMap::getSwitchMapId, isLotoSwitchMap.getSwitchMapId())
                .set(IsLotoSwitchMap::getSwitchMapName, isLotoSwitchMap.getSwitchMapName())
                .set(IsLotoSwitchMap::getSerialNumber, isLotoSwitchMap.getSerialNumber())
                .set(IsLotoSwitchMap::getOrderNum, isLotoSwitchMap.getOrderNum())
                .set(IsLotoSwitchMap::getMapId, isLotoSwitchMap.getMapId() != null ? isLotoSwitchMap.getMapId() : null)
                .set(IsLotoSwitchMap::getWorkstationId, isLotoSwitchMap.getWorkstationId() != null ? isLotoSwitchMap.getWorkstationId() : null)
                .set(IsLotoSwitchMap::getMap, StringUtils.isNotBlank(isLotoSwitchMap.getMap()) ? isLotoSwitchMap.getMap() : null));
        return true;
    }

    @Override
    public IsLotoSwitchMap selectIsLotoSwitchMapById(Long switchMapId) {
        IsLotoSwitchMap byId = getById(switchMapId);
        if (byId != null && byId.getMapId() != null) {
            IsMap map = isMapService.getById(byId.getMapId());
            if (map != null) {
                byId.setMapName(map.getName());
            }
        }
        return byId;
    }

    @Override
    public IsLotoSwitchMap selectSwitchMapBySerialNumber(String serialNumber) {
        Assert.notBlank(serialNumber, "请提供柜序列号！");
        return getOne(Wrappers.<IsLotoSwitchMap>lambdaQuery()
                .eq(IsLotoSwitchMap::getSerialNumber, serialNumber));
    }

    @Override
    public Boolean updatePointsBindingSwitchMap(SwitchBindingPointDTO dto) {
        Assert.notNull(dto.getSwitchMapId(), "开关布局ID不能为空!");
        if (!dto.getBindingPointIds().isEmpty()) {
            // 开始绑定
            iIsIsolationPointService.update(Wrappers.<IsIsolationPoint>lambdaUpdate()
                    .in(IsIsolationPoint::getPointId, dto.getBindingPointIds())
                    .set(IsIsolationPoint::getSwitchMapId, dto.getSwitchMapId()));
        }
        if (!dto.getUnbindPointIds().isEmpty()) {
            // 开始解绑
            iIsIsolationPointService.update(Wrappers.<IsIsolationPoint>lambdaUpdate()
                    .in(IsIsolationPoint::getPointId, dto.getUnbindPointIds())
                    .set(IsIsolationPoint::getSwitchMapId, null));
        }
        return true;
    }

}
